require(['shop', 'bank', 'car', 'bike'], function (shop, bank, car, bike) {

    var myBank = bank({balance: 10000}),
        myShop = shop(myBank),
        itemIds = [];

    // add something to the shop's stock
    itemIds[0] = myShop.buyItem(car({
        sellingPrice    : 2300,
        purchasePrice   : 2000,
        make            : 'VW',
        color           : 'silver',
        mileage         : 100000,
        engineType      : '1.9 diesel',
        model           : 'Passat'
    }));

    itemIds[1] = myShop.buyItem(car({
        sellingPrice    : 8000,
        purchasePrice   : 6500,
        make            : 'Audi',
        color           : 'black',
        mileage         : 55000,
        engineType      : '2.5 petrol',
        model           : 'A4'
    }));

    itemIds[2] = myShop.buyItem(bike({
        sellingPrice    : 800,
        purchasePrice   : 750,
        make            : 'romet',
        color           : 'yellow',
        type            : 'mountain'
    }));

    itemIds[3] = myShop.buyItem(car({
        sellingPrice    : 800,
        purchasePrice   : 700,
        make            : 'Fiat',
        color           : 'red',
        mileage         : 170000,
        engineType      : '1.2 petrol',
        model           : 'Punto'
    }));

    myShop.buyItem(bike({
        sellingPrice    : 500,
        purchasePrice   : 450,
        make            : 'noname',
        color           : 'green',
        type            : 'city'
    }));

    // what is my current balance?
    console.log('My current bank account balance: ', myBank.getBalance());

    // time to sell something and start earning money!
    myShop.sellItem(itemIds[1]);
    myShop.sellItem(itemIds[2]);

    // what is my current balance?
    console.log('My current bank account balance: ', myBank.getBalance());

});