define(['item'], function (item) {
    var car = function (spec) {
        var that = item(spec);

        spec.itemType = 'car';
        spec.mileage = spec.mileage || 'n/a';
        spec.engineType = spec.engineType || 'n/a';
        spec.model = spec.model || 'n/a';

        that.getMileage = function () {
            return spec.mileage;
        };

        that.getEngineType = function () {
            return spec.engineType;
        };

        that.getModel = function () {
            return spec.model;
        };

        return that;
    };
    return car;
});